import heapq
from collections import defaultdict

def solve(n, m, k, roads, guards):
    graph = defaultdict(list)
    for a, b in roads:
        graph[a - 1].append(b - 1)
        graph[b - 1].append(a - 1)
    guarded = set()
    for p, h in guards:
        p -= 1
        q = [(0, p)]
        visited = set()
        while q:
            d, cur = heapq.heappop(q)
            if cur in visited or d > h:
                continue
            visited.add(cur)
            guarded.add(cur)
            for nb in graph[cur]:
                if nb not in visited:
                    heapq.heappush(q, (d + 1, nb))
    result = sorted(guarded)
    return len(result), [x + 1 for x in result]
n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]
cnt, guarded = solve(n, m, k, roads, guards)
print(cnt)
print(" ".join(map(str, guarded)) if guarded else "")
